SoListenerDopplerElement Class Reference

| http://www.sim.no/ http://www.coin3d.org/

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
SoListenerDopplerElement Class Reference
Element Classes

The SoListenerDopplerElement holds the doppler velocity and factor of the current listener.The dopplerVelocity and dopplerFactor is set by SoListener nodes during audio rendering. The SoListenerDopplerElement is used when the SoVRMLSound nodes render themselves. More...

`#include <Inventor/elements/SoListenerDopplerElement.h>`

Inheritance diagram for SoListenerDopplerElement:

## Public Member Functions
virtual void | init (SoState *state)
virtual void | print (FILE *file) const
| Prints the contents of the element (unimplemented)
Public Member Functions inherited from SoReplacedElement
virtual SbBool | matches (const SoElement *element) const
virtual SoElement * | copyMatchInfo () const
uint32_t | getNodeId () const
Public Member Functions inherited from SoElement
const SoType | getTypeId (void) const
int | getStackIndex (void) const
virtual void | push (SoState *state)
virtual void | pop (SoState *state, const SoElement *prevTopElement)
void | setDepth (const int depth)
int | getDepth (void) const
virtual | ~SoElement ()

## Static Public Member Functions
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void * | createInstance (void)
static void | initClass (void)
static void | setDopplerVelocity (SoState *const state, SoNode *const node, const SbVec3f &velocity)
static void | setDopplerFactor (SoState *const state, SoNode *const node, float factor)
static const SbVec3f & | getDopplerVelocity (SoState *const state)
| Returns the current listener's doppler velocity.
static float | getDopplerFactor (SoState *const state)
| Returns the current listener's doppler factor.
Static Public Member Functions inherited from SoReplacedElement
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void | initClass (void)
Static Public Member Functions inherited from SoElement
static void | initClass (void)
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void | initElements (void)
static int | getNumStackIndices (void)
static SoType | getIdFromStackIndex (const int stackIndex)

## Protected Member Functions
virtual | ~SoListenerDopplerElement ()
Protected Member Functions inherited from SoReplacedElement
virtual | ~SoReplacedElement ()
Protected Member Functions inherited from SoElement
| SoElement (void)
void | capture (SoState *const state) const
virtual void | captureThis (SoState *state) const
void | setTypeId (const SoType typeId)
void | setStackIndex (const int index)
SoElement * | getNextInStack (void) const
SoElement * | getNextFree (void) const

## Protected Attributes
SbVec3f | dopplerVelocity
float | dopplerFactor
Protected Attributes inherited from SoReplacedElement
uint32_t | nodeId
Protected Attributes inherited from SoElement
SoType | typeId
int | stackIndex
int | depth

## Additional Inherited Members
Static Protected Member Functions inherited from SoReplacedElement
static SoElement * | getElement (SoState *const state, const int stackIndex, SoNode *const node)
Static Protected Member Functions inherited from SoElement
static SoElement * | getElement (SoState *const state, const int stackIndex)
static const SoElement * | getConstElement (SoState *const state, const int stackIndex)
static int | createStackIndex (const SoType id)
Static Protected Attributes inherited from SoElement
static int | classStackIndex
static SoTypeList * | stackToType

## Detailed Description

The SoListenerDopplerElement holds the doppler velocity and factor of the current listener.

The dopplerVelocity and dopplerFactor is set by SoListener nodes during audio rendering. The SoListenerDopplerElement is used when the SoVRMLSound nodes render themselves.

Be aware that this class is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Since
  Coin 2.0

## Constructor & Destructor Documentation

SoListenerDopplerElement::~SoListenerDopplerElement | ( | void |  | ) |
| protectedvirtual

The destructor.

## Member Function Documentation

void * SoListenerDopplerElement::createInstance | ( | void |  | ) |
| static

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

void SoListenerDopplerElement::initClass | ( | void |  | ) |
| static

This static method initializes static data for the SoListenerDopplerElement class.

void SoListenerDopplerElement::init | ( | SoState * | state | ) |
| virtual

Initializes the element to it's default value. The default value for the velocity is (0.0f, 0.0f, 0.0f), in other words, the listener is not moving. The default value for the dopplerFactor is 0.0f, in other words, doppler effect is disabled.

Reimplemented from SoReplacedElement.

void SoListenerDopplerElement::setDopplerVelocity | ( | SoState *const | state,
|  | SoNode *const | node,
|  | const SbVec3f & | velocity
| ) |  |
| static

Sets the current listener's doppler velocity.

void SoListenerDopplerElement::setDopplerFactor | ( | SoState *const | state,
|  | SoNode *const | node,
|  | float | factor
| ) |  |
| static

Sets the current listener's doppler factor.

## Member Data Documentation

SoListenerDopplerElement::dopplerVelocity
| protected

The doppler velocity of the listener. It is the application programmer's responsibility to set this value. Coin does not update this value automatically based on changes in a listener's position.

SoListenerDopplerElement::dopplerFactor
| protected

The amount of doppler effect applied to the listener. The normal range would be [0.0f to 1.0f], where 0.0f is default and disable all doppler effects.

The documentation for this class was generated from the following files:

- SoListenerDopplerElement.h
- SoListenerDopplerElement.cpp

Copyright © 1998-2010 by Kongsberg Oil & Gas Technologies. All rights reserved.